import ../src/nimbotsdk/[matrixTypes, MatrixClient, mixins/AutojoinRoomsMixin]
import ../src/nimbotsdk/storage/[SimpleFsStorageProvider, RustSdkCryptoStorageProvider]

const
    homeserver: cstring = "https://matrix.example.xyz"
    token: cstring = "token"

let storage = newSimpleFsStorageProvider("storage.json")
let cryptoStorage = newRustSdkCryptoStorageProvider("./cryptoStorage/")

let client = newMatrixClient(homeserver, token, storage, cryptoStorage)

AutojoinRoomsMixinSetupOnClient(client)

client.start()

client.onRoomMessage(proc(roomId: cstring, event: Event) = 
    if(event.content.body == "ping"):
        client.replyNotice(roomId, event, "pong", "<h1><em>pong!</em></h1>")
    )